				;//////////////////
Global GameTitle$="3x3 Words"
				;\\\\\\\\\\\\\\\\\\
					; A Wednesday Workshop Game by
	Global AuthorName$="Jayenkai"

ChangeDir("system")
ChangeDir("245")


; Enter your game title and your name above, then Ctrl+End to the bottom, where the gameplay function is.

Global jscrw=800:Global jscrh=600
Graphics jscrw,jscrh,0,2
SetBuffer BackBuffer()

Global UseFont$="Blitz"

Global mdis=0

Global sfx1=LoadSound("001.wav")
Global sfx2=LoadSound("002.wav")
Global sfx3=LoadSound("003.wav")


; Load images and stuff, here

Global Word$[2048]
Global Bag[220]
Global BagTo,BagTot
Dim get$(256)
Global manywords=0
quickin=ReadFile("words.txt")
Repeat
	in$=ReadLine(quickin)
	If  Len(in$)=3 Then manywords=manywords+1:word[manywords]=Upper$(in$)
Until Eof(quickin)

CloseFile quickin



Global HighScore=0,LastScore=0
If FileType("score.dat")=1
	quickin=ReadFile("score.dat")
		HighScore=ReadInt(quickin)
	CloseFile quickin
EndIf

Global font_[10]
For n=0 To 9
	font_[n]=LoadFont(UseFont,(n+1)*8)
Next


Global Mode=0,frm=0,kdis=0

Global lastframe,frametook,fps,DebugMode=0
Global plr#[100],grid#[10000001],obj#[5130],but[20]
Global played=0,Score,ShowScore
Global bgr#=0,bgg#=0,bgb#=0
Global bgrAim#=0,bggAim=0,bgbAim#=0
Global EndofGame,EndTimer


Repeat
PollKeys()
bgr=bgr-((bgr-bgrAim)/8.0)
bgg=bgg-((bgg-bggAim)/8.0)
bgb=bgb-((bgb-bgbAim)/8.0)
ClsColor bgr,bgg,bgb
Cls


	If Mode=0 ; Titlescreen
		TitleScreen()
		If Played=1
			Played=0
			LastScore=Score
		If Score>HighScore
			HighScore=Score
			quickout=WriteFile("score.dat")
			If quickout<>0
				WriteInt(quickout,HighScore)
				CloseFile quickout
			EndIf
		EndIf
		EndIf
	EndIf
	If Mode=1 ; Ingame
		GamePlay():Played=1:If KeyDown(1) Then kdis=1:Mode=0
		If EndofGame<>0
			EndTimer=EndTimer+1
			If EndTimer>60 Then Mode=0
			font(7):ink(1,0.75)
			Text(jscrw/2-64,jscrh/2-24,"GAME",1,1)
			Text(jscrw/2+64,jscrh/2+24,"OVER",1,1)
		EndIf		
	EndIf
	
	If (PlayKey(10) Or PlayKey(11) Or PlayKey(12) Or MouseDown(1)) And Mode=0 Then GameSetup():Mode=1
	
	
	If PlayKey(0)=0 And PlayKey(3)=0 And PlayKey(5)=0 And PlayKey(8)=0 And PlayKey(10)=0 And PlayKey(11)=0 And PlayKey(12)=0 And KeyDown(1)=0 Then kdis=0
	
If DebugMode=1 Then font(1):Ink(9):Text 10,jscrh-20,"FPS : "+fps
If KeyHit(59) Then DebugMode=1-DebugMode ;F1 to toggle DebugMode
Flip:Delay 5
frametook=MilliSecs()-lastframe
fps=1000/frametook
lastframe=MilliSecs()
frm=frm+1

fin=0
If (KeyDown(1) And Mode=0 And kdis=0) Or KeyDown(62) Then fin=1
Until fin=1
End


Function PlayKey(fn)
If fn>-1 And fn<20 Then Return but[fn]
Return 0
End Function ; PlayKey

Function PollKeys()
	but[0]=KeyDown(17) Or KeyDown(200) Or JoyY()<-0.3 Or JoyY(1)<-0.3 Or JoyY(2)<-0.3 Or JoyY(3)<-0.3 
	but[8]=KeyDown(31) Or KeyDown(208) Or JoyY()>0.3 Or JoyY(1)>0.3 Or JoyY(2)>0.3 Or JoyY(3)>0.3 
	but[3]=KeyDown(30) Or KeyDown(203) Or JoyX()<-0.3 Or JoyX(1)<-0.3 Or JoyX(2)<-0.3 Or JoyX(3)<-0.3 
	but[5]=KeyDown(32) Or KeyDown(205) Or JoyX()>0.3 Or JoyX(1)>0.3 Or JoyX(2)>0.3 Or JoyX(3)>0.3 
	
	but[10]=KeyDown(36) Or KeyDown(44) Or KeyDown(57) Or JoyDown(1) Or JoyDown(1,1) Or JoyDown(1,2) Or JoyDown(1,3)
	but[11]=KeyDown(37) Or KeyDown(45) Or KeyDown(29) Or KeyDown(157) Or JoyDown(2) Or JoyDown(2,1) Or JoyDown(2,2) Or JoyDown(2,3)
	but[12]=KeyDown(38) Or KeyDown(46) Or KeyDown(42) Or KeyDown(56) Or KeyDown(54) Or JoyDown(3) Or JoyDown(3,1) Or JoyDown(3,2) Or JoyDown(3,3)
End Function; PlayKey


Function ink(fn,fbright#=1.0)
Local r,g,b,l
l=0
If fbright>1.0 Then l=40

	Select fn
		Case 1	r=255:g=l:b=l		; 1 = Red
		Case 2	r=255:g=128:b=l		; 2 = Orange
		Case 3	r=255:g=255:b=l		; 3 = Yellow
		Case 4	r=l:g=255:b=l		; 4 = Green
		Case 5	r=l:g=128:b=255		; 5 = Cyan
		Case 6	r=l:g=l:b=255		; 6 = Blue
		Case 7	r=128:g=l:b=255		; 7 = Bluey Purple
		Case 8	r=255:g=l:b=128		; 8 = Redy Purple
		Case 9	r=255:g=255:b=255	; 9 = White
		Default	r=0:g=0:b=0			; 0/unknown = Black

	End Select



	r=r*fbright
	g=g*fbright
	b=b*fbright
	If r<0 Then r=0
	If r>255 Then r=255
	If g<0 Then g=0
	If g>255 Then g=255
	If b<0 Then b=0
	If b>255 Then b=255
Color(r,g,b)
End Function


Function font(fn)
If n>-1 And fn<10
	SetFont font_[fn]
EndIf
End Function


Function FlushGame()
EndofGame=0
EndTimer=0
For m=0 To 10000001
	If m<100 Then plr[m]=0
	If m<5130 Then obj[m]=0
	grid[m]=0
Next
Score=0
End Function	;Flush Game



Function SetBG(r,g,b)	; Sets the background color
	bgrAim=r
	bggAim=g
	bgbAim=b
End Function


Function ReSeed(fn=-37171650)
	If fn=-37171650 Then SeedRnd MilliSecs()
	If fn<>-37171650 Then SeedRnd fn
	Local fm
	For fm=0 To 99:fn=Rnd(0,100):Next
End Function


Function MouseIn(x,y,w,h)
If MouseX()>x=1 And MouseY()>y-1 And MouseX()<x+w And MouseY()<y+h Then Return 1
Return 0
End Function


Function DisplayScore()	; Shows the score, and updates the ShowScore variable
	If Abs(ShowScore-Score)<8 Then ShowScore=Score
	ShowScore=ShowScore-((ShowScore-Score)/Rand(6,12))
	Font(2):Ink(4,4):Text(jscrw/2,32,Right$("00000000"+ShowScore,8),1,1)
End Function



Function KeyTest()	; Random oddity for test purposes
font(5):ink(9)
	Text(100,100,PlayKey(0),1,1)	; 0 = up
	Text(100,160,PlayKey(8),1,1)	; 8 = down

	Text(70,130,PlayKey(3),1,1)		; 3 = Left
	Text(130,130,PlayKey(5),1,1)	; 5 = Right
	
ink(1):Text(300,130,PlayKey(10),1,1); 10 = Button A
ink(3):Text(320,120,PlayKey(11),1,1); 11 = Button B
ink(5):Text(340,110,PlayKey(12),1,1); 12 = Button C

	If PlayKey(0) Then Score=Score+10
	If PlayKey(8) Then Score=Score-10
	If Score<0 Then Score=0


End Function






Function Titlescreen()
	SetBG(20,40,80)	; Set the colour of the background
	
	; Basic generic titlescreen.  Feel free to jazz it up a bit!
	ink(3,(Sin(frm*8)*0.5)+1.0):font(7)
	Text(jscrw/2,60,GameTitle$,1,1)
	ink(2):font(3)
	Text(jscrw*0.75,94,"a game by "+AuthorName$,1,1)

	ink(((MilliSecs() /450) Mod 9)+1)
	Text(jscrw/2,jscrh/2-64,"Click to [Start]",1,1)
	
	ink(4)
	Text(jscrw/2,jscrh/2+64,"Get as many 3 letter",1,1)
	Text(jscrw/2,jscrh/2+86,"words as you can",1,1)
	

	ink(5,2):font(2)
	Text(jscrw/2,jscrh-94,"High Score : "+HighScore,1,1)
	Text(jscrw/2,jscrh-32,"Last Score : "+LastScore,1,1)

End Function	; Titlescreen




;\/\/\/\/\/\/\/\/\/\/
; v GAME GOES HERE v
;\/\/\/\/\/\/\/\/\/\/

Function FillBag()
BagTot=0
	For l=1 To 26
		many=1
		If l=1 Then many=18
		If l=2 Then many=5
		If l=3 Then many=5
		If l=4 Then many=8
		If l=5 Then many=24
		If l=6 Then many=4
		If l=7 Then many=6
		If l=8 Then many=4
		If l=9 Then many=17
		If l=10 Then many=2
		If l=11 Then many=2
		If l=12 Then many=8
		If l=13 Then many=4
		If l=14 Then many=13
		If l=15 Then many=14
		If l=16 Then many=4
		If l=17 Then many=2
		If l=18 Then many=12
		If l=19 Then many=8
		If l=20 Then many=12
		If l=21 Then many=8
		If l=22 Then many=4
		If l=23 Then many=4
		If l=24 Then many=2
		If l=25 Then many=4
		If l=26 Then many=2
		
		For m=1 To many
			bag[BagTot]=l
			BagTot=BagTot+1
		Next
	Next
	BagTo=0
	For e=0 To BagTot-1
		r=Rand(0,BagTot-1)
		t=Bag[e]
		Bag[e]=Bag[r]
		Bag[r]=t
	Next
End Function


Function NextLetter()
	BagTo=BagTo+1
	If BagTo=BagTot Then FillBag()
	Return Bag[BagTo]
End Function

Function GameSetup()
FlushGame()
ReSeed()
mdis=1
FillBag()

plr[99]=3

For n=0 To 250
	get$(n)=""
Next

For n=0 To 4
grid[n+10]=NextLetter()
Next

; Initialise your variables/level/etc here
End Function ; Game Setup


Function GiveWord(wrd$)
For n=250 To 1 Step -1
	get$(n)=get$(n-1)
Next
get$(0)=wrd$
End Function


Function CheckRow(fx)
	gets=0
	test$=""
	test$=Chr$(grid[(0*3)+fx])+Chr$(grid[(1*3)+fx])+Chr$(grid[(2*3)+fx])
	DebugLog "Word "+test
	For m=1 To manywords
		If Upper$(word[m])=Upper$(test$)	
			d=1
			For e=0 To 250
				If Upper$(test)=get$(e) Then d=0
			Next
			If d=1 Then gets=1:Score=Score+25:GiveWord(Upper$(test))
		EndIf
	Next
	Return gets
End Function
Function CheckCol(fy)
	gets=0
	test$=""
	test$=Chr$(grid[(fy*3)+0])+Chr$(grid[(fy*3)+1])+Chr$(grid[(fy*3)+2])
	DebugLog "Word "+test	
	For m=1 To manywords
		If Upper$(word[m])=Upper$(test$) 
			d=1
			For e=0 To 250
				If Upper$(test)=get$(e) Then d=0
			Next
			If d=1 Then gets=1:Score=Score+25:GiveWord(Upper$(test))
		EndIf
	Next
	Return gets
End Function


Function GamePlay()
	SetBG(0,0,0)	; Set the colour of the background.

	For x=0 To 1
		Rect((x*200)+300,50,8,500)
	Next
	For y=0 To 1
		Rect(150,(y*200)+200,500,8)
	Next

font(8)

For x=0 To 2
For y=0 To 2
	If MouseIn(((x-1)*200)+314,((y-1)*200)+214,180,180) And EndofGame=0
		Color(0,80,160)
		Rect(((x-1)*200)+314,((y-1)*200)+214,180,180)
		
		If mdis=0 And MouseDown(1)
			mdis=1
			w=grid[y*3+x]
			grid[y*3+x]=grid[10]+64
			
			
			a=CheckRow(x)
			b=CheckCol(y)
			
			If a=1 Or b=1 Or w=0 Then PlaySound(sfx2)
			If a=1 And b=1 Then Score=Score+100
			If a>0  Or b>0 Then PlaySound(sfx3)
			If w>0 And a=0 And b=0 Then plr[99]=plr[99]-1:PlaySound(sfx1)
						
			
			For n=0 To 3
			grid[n+10]=grid[n+11]
			Next
			grid[14]=NextLetter()
		EndIf
	EndIf
	If grid[(y*3)+x]>0
		Color 255,255,255
		Text(((x-1)*200)+314+90,((y-1)*200)+214+90,Chr$(grid[(y*3)+x]),1,1)
	EndIf
	
	If grid[(y*3)+x]=0
		font(3)
		Color 255,255,100
		Text(((x-1)*200)+314+90,((y-1)*200)+214+90-10,"Free",1,1)
		Text(((x-1)*200)+314+90,((y-1)*200)+214+90+10,"Tile",1,1)
		font(8)
	EndIf
Next
Next





Color(0,180,0)
Oval(jscrw-98,140-34,68,68)
Color(0,40,0)
Oval(jscrw-96,140-32,64,64)


font(2)
Color(50,180,255)
y=8
n=0
Repeat
f=0
Text(10,y,get$(n))

n=n+1
y=y+20
If get$(n)="" Then f=1
If y>jscrh Then f=1


Until f=1

font(6)
For n=0 To 4
	Color(255-(n*60),255-(n*60),255-(n*60))
	Text(jscrw-64,((n+1)*90)+50,Chr$(grid[n+10]+64),1,1)
Next

If MouseDown(1)=0 Then mdis=0


font(3)
Color(255,0,0)
x=jscrw-64
For e=1 To plr[99]
	Text x,24,"o",1,1
	Text x,24,"u",1,1
	x=x+16
Next
If plr[99]<0 Then EndofGame=1

	; If you set EndofGame=1, the game will end with a Game Over banner.
	DisplayScore()
End Function	; Gameplay